Bug 20472 - Add digital scan as optional format to Article Requests
Summary: Add digital scan as optional format to Article Requests
Status: CLOSED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Circulation (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Marcel de Rooy
QA Contact: Testopia
URL:
Keywords:
Depends on: 20469
Blocks: 20570
  Show dependency treegraph
 
Reported: 2018-03-26 12:25 UTC by Marcel de Rooy
Modified: 2022-06-06 20:25 UTC (History)
6 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Documentation contact:
Documentation submission:
Text to go in the release notes:
This patch set adds an additional (optional) format to Article Requests. Allowing a user to request a digital copy. In staff the request can be processed by entering a download URL. This serves as a base for further automation.
Version(s) released in:
21.11.00


Attachments
Bug 20472: Add new fields article_requests.format and urls (2.26 KB, patch)
2020-07-29 14:48 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats (3.76 KB, patch)
2020-07-29 14:48 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add format field to the interface (14.03 KB, patch)
2020-07-29 14:48 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add format to sample notices (3.28 KB, patch)
2020-07-29 14:48 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Edit URL field on staff form (10.36 KB, patch)
2020-07-29 14:48 UTC, Marcel de Rooy
Details | Diff | Splinter Review
DO_NOT_PUSH: Change DBIx schema file ArticleRequest (1.75 KB, patch)
2020-07-29 14:48 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Update translated AR notices (68.07 KB, patch)
2020-07-29 14:48 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add new fields article_requests.format and urls (2.26 KB, patch)
2020-10-12 08:00 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats (3.76 KB, patch)
2020-10-12 08:00 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add format field to the interface (14.13 KB, patch)
2020-10-12 08:00 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add format to sample notices (3.28 KB, patch)
2020-10-12 08:00 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Edit URL field on staff form (10.50 KB, patch)
2020-10-12 08:00 UTC, Marcel de Rooy
Details | Diff | Splinter Review
DO_NOT_PUSH: Change DBIx schema file ArticleRequest (1.80 KB, patch)
2020-10-12 08:00 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Update translated AR notices (68.07 KB, patch)
2020-10-12 08:00 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add new fields article_requests.format and urls (1.41 KB, patch)
2021-06-24 09:31 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats (3.78 KB, patch)
2021-06-24 09:31 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add format field to the interface (14.17 KB, patch)
2021-06-24 09:31 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Edit URL field on staff form (10.49 KB, patch)
2021-06-24 09:31 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add format to sample notices (3.28 KB, patch)
2021-06-24 09:32 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Update translated AR notices (25.75 KB, patch)
2021-06-24 09:32 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: [DO NOT PUSH] DBIx schema changes (1.76 KB, patch)
2021-06-24 09:32 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add new fields article_requests.format and urls (1.44 KB, patch)
2021-06-24 10:07 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats (3.80 KB, patch)
2021-06-24 10:07 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 20472: Add format field to the interface (14.19 KB, patch)
2021-06-24 10:08 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 20472: Edit URL field on staff form (10.51 KB, patch)
2021-06-24 10:08 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 20472: Add format to sample notices (3.31 KB, patch)
2021-06-24 10:08 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 20472: Update translated AR notices (25.77 KB, patch)
2021-06-24 10:08 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 20472: [DO NOT PUSH] DBIx schema changes (1.79 KB, patch)
2021-06-24 10:08 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 20472: (QA follow-up) Add few TT filters (5.08 KB, patch)
2021-06-24 12:13 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: [DO NOT PUSH] DBIx schema changes (1.83 KB, patch)
2021-06-24 12:13 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 20472: Add new fields article_requests.format and urls (1.49 KB, patch)
2021-07-09 11:09 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats (3.86 KB, patch)
2021-07-09 11:09 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: Add format field to the interface (14.25 KB, patch)
2021-07-09 11:09 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: Edit URL field on staff form (10.57 KB, patch)
2021-07-09 11:09 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: Add format to sample notices (3.36 KB, patch)
2021-07-09 11:09 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: Update translated AR notices (25.83 KB, patch)
2021-07-09 11:09 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: (QA follow-up) Add few TT filters (5.10 KB, patch)
2021-07-09 11:10 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: [DO NOT PUSH] DBIx schema changes (1.84 KB, patch)
2021-07-09 11:10 UTC, Nick Clemens
Details | Diff | Splinter Review
Bug 20472: Make DB rev idempotent (1.45 KB, patch)
2021-07-12 11:52 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 20472: Add kohastructure changes (1.15 KB, patch)
2021-07-12 13:37 UTC, Jonathan Druart
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Marcel de Rooy 2018-03-26 12:25:39 UTC

    
Comment 1 Marcel de Rooy 2018-04-11 13:39:07 UTC
Have this patch set in test stage on 16.11. Plan to move them upwards after the 18.05 release.
Comment 2 Marcel de Rooy 2020-07-29 14:48:24 UTC
Created attachment 107506 [details] [review]
Bug 20472: Add new fields article_requests.format and urls

The field 'format' will allow to make a distinction between requests for
photocopies and digital scans.
The field 'urls' will be used to save the URLs that allow the client to
download the scanned materials.

Test plan:
Run new install or upgrade existing install with atomic update.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 3 Marcel de Rooy 2020-07-29 14:48:28 UTC
Created attachment 107507 [details] [review]
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats

This preference controls which formats are actually offered to patrons of
the library via the Article Request feature.
By default, it only contains PHOTOCOPY. This is default behavior.

The request format SCAN will be made possible by this report and can be
added by changing the preference.

Test plan:
Run the dbrev. Check the new pref on Administration.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 4 Marcel de Rooy 2020-07-29 14:48:33 UTC
Created attachment 107508 [details] [review]
Bug 20472: Add format field to the interface

We need to add the format to the forms entering new requests:
  opac/opac-request-article
  circ/request-article
If the pref contains multiple formats like SCAN|PHOTOCOPY, the first listed
format will be preselected on the request form. If there is only one option,
we should not disable the select however. (Possibly hide it.)

If we have no mandatory fields, we should not allow the submit of a complete
empty form (check on OPAC).

And we need to show the format of pending requests on forms:
  opac/opac-user
  circ/request-article (biblio detail tab)
  circ/article-requests (staff form to handle requests)
  members/moremember (Article requests tab at the bottom)
  circ/circulation (Checkout/Article requests tab)
Note: The last two forms use the same include file.

Test plan:
[1] Add an article request via opac or staff. Choose Scan.
[2] Verify that you see the Scan format on opac-user and the
    above-mentioned staff forms.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 5 Marcel de Rooy 2020-07-29 14:48:37 UTC
Created attachment 107509 [details] [review]
Bug 20472: Add format to sample notices

NOTE: We are only changing English here. A follow-up will care for
the translated languages. (English is in yml format, the remainder
not yet.)

We need to change the following notices:
AR_SLIP, AR_CANCELED, AR_PROCESSING, AR_PENDING and AR_COMPLETED.
In AR_COMPLETED the last sentence about picking up has been modified
too.

Test plan:
Reinstall Koha. Choose English. Check notice text.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 6 Marcel de Rooy 2020-07-29 14:48:42 UTC
Created attachment 107510 [details] [review]
Bug 20472: Edit URL field on staff form

This patch makes the following changes:

Add menu option Edit URLs.
Edit modal form to edit URLs.
Save URLs via ajax call to svc/article_request (Add action update_urls).
Add URL column to pending and processing table.
Allow Edit URLs for pending table too (just as Complete).
Do not allow 'Complete request' if a scan request has no URL(s).

Test plan:
[1] Add a few scan and photocopy requests.
[2] Fill url-A and url-B in two separate scan requests.
[3] Verify that these two urls are really saved (refresh form).
[4] Check that you cannot complete a scan request without URL and that you
    cannot add a URL to a photocopy request.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 7 Marcel de Rooy 2020-07-29 14:48:46 UTC
Created attachment 107511 [details] [review]
DO_NOT_PUSH: Change DBIx schema file ArticleRequest
Comment 8 Marcel de Rooy 2020-07-29 14:48:50 UTC
Created attachment 107512 [details] [review]
Bug 20472: Update translated AR notices

de-DE/mandatory/sample_notices.sql
fr-CA/obligatoire/sample_notices.sql
fr-FR/1-Obligatoire/sample_notices.sql
it-IT/necessari/notices.sql
nb-NO/1-Obligatorisk/sample_notices.sql
pl-PL/mandatory/sample_notices.sql
ru-RU/mandatory/sample_notices.sql
uk-UA/mandatory/sample_notices.sql

Test plan:
Reinstall notices for one of the languages above.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Have run all sql files thru mysql on the command line.
Comment 9 Marcel de Rooy 2020-07-29 14:50:22 UTC
(In reply to Marcel de Rooy from comment #1)
> Have this patch set in test stage on 16.11. Plan to move them upwards after
> the 18.05 release.

The plan changed ;) This patch set has run in production on 16.11 and 18.05. And I rebased for 19.11 and master now.
Comment 10 Marcel de Rooy 2020-07-29 14:55:36 UTC
Adding bug 26088 as a see also (for now) on this report in order to address financial follow-up for such a service.
Comment 11 Owen Leonard 2020-07-29 17:09:00 UTC
Can you explain more about how the URL field is supposed to be used? Where do the URLs come from?
Comment 12 Marcel de Rooy 2020-07-29 17:50:19 UTC
(In reply to Owen Leonard from comment #11)
> Can you explain more about how the URL field is supposed to be used? Where
> do the URLs come from?

Good question. I leave some room for customization here too. (We use the AR slip and OCR to tag scanned files with the article request number. And then use opac/svc/requests (see bug 20570 follow-up) to add a Dropbox link to the request.) But bug 20570 also contains complete_article_requests.pl to match uploaded files in Koha with article requests.

Apart from bug 20570, this development here allows you to manually add links (without saying how they were created indeed).
Comment 13 Marcel de Rooy 2020-10-12 08:00:20 UTC
Created attachment 111473 [details] [review]
Bug 20472: Add new fields article_requests.format and urls

The field 'format' will allow to make a distinction between requests for
photocopies and digital scans.
The field 'urls' will be used to save the URLs that allow the client to
download the scanned materials.

Test plan:
Run new install or upgrade existing install with atomic update.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 14 Marcel de Rooy 2020-10-12 08:00:25 UTC
Created attachment 111474 [details] [review]
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats

This preference controls which formats are actually offered to patrons of
the library via the Article Request feature.
By default, it only contains PHOTOCOPY. This is default behavior.

The request format SCAN will be made possible by this report and can be
added by changing the preference.

Test plan:
Run the dbrev. Check the new pref on Administration.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 15 Marcel de Rooy 2020-10-12 08:00:30 UTC
Created attachment 111475 [details] [review]
Bug 20472: Add format field to the interface

We need to add the format to the forms entering new requests:
  opac/opac-request-article
  circ/request-article
If the pref contains multiple formats like SCAN|PHOTOCOPY, the first listed
format will be preselected on the request form. If there is only one option,
we should not disable the select however. (Possibly hide it.)

If we have no mandatory fields, we should not allow the submit of a complete
empty form (check on OPAC).

And we need to show the format of pending requests on forms:
  opac/opac-user
  circ/request-article (biblio detail tab)
  circ/article-requests (staff form to handle requests)
  members/moremember (Article requests tab at the bottom)
  circ/circulation (Checkout/Article requests tab)
Note: The last two forms use the same include file.

Test plan:
[1] Add an article request via opac or staff. Choose Scan.
[2] Verify that you see the Scan format on opac-user and the
    above-mentioned staff forms.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 16 Marcel de Rooy 2020-10-12 08:00:35 UTC
Created attachment 111476 [details] [review]
Bug 20472: Add format to sample notices

NOTE: We are only changing English here. A follow-up will care for
the translated languages. (English is in yml format, the remainder
not yet.)

We need to change the following notices:
AR_SLIP, AR_CANCELED, AR_PROCESSING, AR_PENDING and AR_COMPLETED.
In AR_COMPLETED the last sentence about picking up has been modified
too.

Test plan:
Reinstall Koha. Choose English. Check notice text.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 17 Marcel de Rooy 2020-10-12 08:00:41 UTC
Created attachment 111477 [details] [review]
Bug 20472: Edit URL field on staff form

This patch makes the following changes:

Add menu option Edit URLs.
Edit modal form to edit URLs.
Save URLs via ajax call to svc/article_request (Add action update_urls).
Add URL column to pending and processing table.
Allow Edit URLs for pending table too (just as Complete).
Do not allow 'Complete request' if a scan request has no URL(s).

Test plan:
[1] Add a few scan and photocopy requests.
[2] Fill url-A and url-B in two separate scan requests.
[3] Verify that these two urls are really saved (refresh form).
[4] Check that you cannot complete a scan request without URL and that you
    cannot add a URL to a photocopy request.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 18 Marcel de Rooy 2020-10-12 08:00:49 UTC
Created attachment 111478 [details] [review]
DO_NOT_PUSH: Change DBIx schema file ArticleRequest
Comment 19 Marcel de Rooy 2020-10-12 08:00:57 UTC
Created attachment 111479 [details] [review]
Bug 20472: Update translated AR notices

de-DE/mandatory/sample_notices.sql
fr-CA/obligatoire/sample_notices.sql
fr-FR/1-Obligatoire/sample_notices.sql
it-IT/necessari/notices.sql
nb-NO/1-Obligatorisk/sample_notices.sql
pl-PL/mandatory/sample_notices.sql
ru-RU/mandatory/sample_notices.sql
uk-UA/mandatory/sample_notices.sql

Test plan:
Reinstall notices for one of the languages above.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Have run all sql files thru mysql on the command line.
Comment 20 Marcel de Rooy 2020-10-12 08:05:43 UTC
Rebased. Please test ! Last submit waited three months.
Comment 21 Marcel de Rooy 2021-06-24 08:16:59 UTC
This development is actually very important for us and received no interest from anyone since 2018.
Obviously it did and does not apply anymore at some point in time.
Comment 22 Marcel de Rooy 2021-06-24 08:21:12 UTC
CONFLICT (modify/delete): installer/data/mysql/uk-UA/mandatory/sample_notices.sql deleted in HEAD and modified in Bug 20472: Update translated AR notices. Version Bug 20472: Update translated AR notices of installer/data/mysql/uk-UA/mandatory/sample_notices.sql left in tree.
CONFLICT (modify/delete): installer/data/mysql/ru-RU/mandatory/sample_notices.sql deleted in HEAD and modified in Bug 20472: Update translated AR notices. Version Bug 20472: Update translated AR notices of installer/data/mysql/ru-RU/mandatory/sample_notices.sql left in tree.
CONFLICT (modify/delete): installer/data/mysql/pl-PL/mandatory/sample_notices.sql deleted in HEAD and modified in Bug 20472: Update translated AR notices. Version Bug 20472: Update translated AR notices of installer/data/mysql/pl-PL/mandatory/sample_notices.sql left in tree.

I will leave these out now.
Comment 23 Marcel de Rooy 2021-06-24 08:25:44 UTC
CONFLICT (modify/delete): installer/data/mysql/it-IT/necessari/notices.sql deleted in HEAD and modified in Bug 20472: Update translated AR notices. Version Bug 20472: Update translated AR notices of installer/data/mysql/it-IT/necessari/notices.sql left in tree.
CONFLICT (modify/delete): installer/data/mysql/de-DE/mandatory/sample_notices.sql deleted in HEAD and modified in Bug 20472: Update translated AR notices. Version Bug 20472: Update translated AR notices of installer/data/mysql/de-DE/mandatory/sample_notices.sql left in tree.

Could be added back later on.
Comment 24 Marcel de Rooy 2021-06-24 09:27:30 UTC
(In reply to Marcel de Rooy from comment #9)
> The plan changed ;) This patch set has run in production on 16.11 and 18.05.
> And I rebased for 19.11 and master now.

So I had this stuff on 16.11, 18.05, 19.11, 20.06 and 21.06 now :)
Comment 25 Marcel de Rooy 2021-06-24 09:29:20 UTC
Note for QA:

Should we try to update existing notices here too ?
Comment 26 Marcel de Rooy 2021-06-24 09:31:46 UTC
Created attachment 122366 [details] [review]
Bug 20472: Add new fields article_requests.format and urls

The field 'format' will allow to make a distinction between requests for
photocopies and digital scans.
The field 'urls' will be used to save the URLs that allow the client to
download the scanned materials.

Test plan:
Run new install or upgrade existing install with atomic update.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 27 Marcel de Rooy 2021-06-24 09:31:49 UTC
Created attachment 122367 [details] [review]
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats

This preference controls which formats are actually offered to patrons of
the library via the Article Request feature.
By default, it only contains PHOTOCOPY. This is default behavior.

The request format SCAN will be made possible by this report and can be
added by changing the preference.

Test plan:
Run the dbrev. Check the new pref on Administration.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 28 Marcel de Rooy 2021-06-24 09:31:53 UTC
Created attachment 122368 [details] [review]
Bug 20472: Add format field to the interface

We need to add the format to the forms entering new requests:
  opac/opac-request-article
  circ/request-article
If the pref contains multiple formats like SCAN|PHOTOCOPY, the first listed
format will be preselected on the request form. If there is only one option,
we should not disable the select however. (Possibly hide it.)

If we have no mandatory fields, we should not allow the submit of a complete
empty form (check on OPAC).

And we need to show the format of pending requests on forms:
  opac/opac-user
  circ/request-article (biblio detail tab)
  circ/article-requests (staff form to handle requests)
  members/moremember (Article requests tab at the bottom)
  circ/circulation (Checkout/Article requests tab)
Note: The last two forms use the same include file.

Test plan:
[1] Add an article request via opac or staff. Choose Scan.
[2] Verify that you see the Scan format on opac-user and the
    above-mentioned staff forms.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 29 Marcel de Rooy 2021-06-24 09:31:57 UTC
Created attachment 122369 [details] [review]
Bug 20472: Edit URL field on staff form

This patch makes the following changes:

Add menu option Edit URLs.
Edit modal form to edit URLs.
Save URLs via ajax call to svc/article_request (Add action update_urls).
Add URL column to pending and processing table.
Allow Edit URLs for pending table too (just as Complete).
Do not allow 'Complete request' if a scan request has no URL(s).

Test plan:
[1] Add a few scan and photocopy requests.
[2] Fill url-A and url-B in two separate scan requests.
[3] Verify that these two urls are really saved (refresh form).
[4] Check that you cannot complete a scan request without URL and that you
    cannot add a URL to a photocopy request.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 30 Marcel de Rooy 2021-06-24 09:32:00 UTC
Created attachment 122370 [details] [review]
Bug 20472: Add format to sample notices

NOTE: We are only changing English here. A follow-up will care for
the translated languages. (English is in yml format, the remainder
not yet.)

We need to change the following notices:
AR_SLIP, AR_CANCELED, AR_PROCESSING, AR_PENDING and AR_COMPLETED.
In AR_COMPLETED the last sentence about picking up has been modified
too.

Test plan:
Reinstall Koha. Choose English. Check notice text.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 31 Marcel de Rooy 2021-06-24 09:32:04 UTC
Created attachment 122371 [details] [review]
Bug 20472: Update translated AR notices

Originally, we had:
de-DE/mandatory/sample_notices.sql
fr-CA/obligatoire/sample_notices.sql
fr-FR/1-Obligatoire/sample_notices.sql
it-IT/necessari/notices.sql
nb-NO/1-Obligatorisk/sample_notices.sql
pl-PL/mandatory/sample_notices.sql
ru-RU/mandatory/sample_notices.sql
uk-UA/mandatory/sample_notices.sql

Obviously, the landscape changed in the meantime.
We still have: fr-CA, fr-FR, nb-NO.

Test plan:
Reinstall notices for one of the languages above.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Have run all sql files thru mysql on the command line.
Comment 32 Marcel de Rooy 2021-06-24 09:32:08 UTC
Created attachment 122372 [details] [review]
Bug 20472: [DO NOT PUSH] DBIx schema changes

Refreshed 24-06-21
Comment 33 Martin Renvoize 2021-06-24 10:07:54 UTC
Created attachment 122373 [details] [review]
Bug 20472: Add new fields article_requests.format and urls

The field 'format' will allow to make a distinction between requests for
photocopies and digital scans.
The field 'urls' will be used to save the URLs that allow the client to
download the scanned materials.

Test plan:
Run new install or upgrade existing install with atomic update.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 34 Martin Renvoize 2021-06-24 10:07:58 UTC
Created attachment 122374 [details] [review]
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats

This preference controls which formats are actually offered to patrons of
the library via the Article Request feature.
By default, it only contains PHOTOCOPY. This is default behavior.

The request format SCAN will be made possible by this report and can be
added by changing the preference.

Test plan:
Run the dbrev. Check the new pref on Administration.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 35 Martin Renvoize 2021-06-24 10:08:03 UTC
Created attachment 122375 [details] [review]
Bug 20472: Add format field to the interface

We need to add the format to the forms entering new requests:
  opac/opac-request-article
  circ/request-article
If the pref contains multiple formats like SCAN|PHOTOCOPY, the first listed
format will be preselected on the request form. If there is only one option,
we should not disable the select however. (Possibly hide it.)

If we have no mandatory fields, we should not allow the submit of a complete
empty form (check on OPAC).

And we need to show the format of pending requests on forms:
  opac/opac-user
  circ/request-article (biblio detail tab)
  circ/article-requests (staff form to handle requests)
  members/moremember (Article requests tab at the bottom)
  circ/circulation (Checkout/Article requests tab)
Note: The last two forms use the same include file.

Test plan:
[1] Add an article request via opac or staff. Choose Scan.
[2] Verify that you see the Scan format on opac-user and the
    above-mentioned staff forms.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 36 Martin Renvoize 2021-06-24 10:08:06 UTC
Created attachment 122376 [details] [review]
Bug 20472: Edit URL field on staff form

This patch makes the following changes:

Add menu option Edit URLs.
Edit modal form to edit URLs.
Save URLs via ajax call to svc/article_request (Add action update_urls).
Add URL column to pending and processing table.
Allow Edit URLs for pending table too (just as Complete).
Do not allow 'Complete request' if a scan request has no URL(s).

Test plan:
[1] Add a few scan and photocopy requests.
[2] Fill url-A and url-B in two separate scan requests.
[3] Verify that these two urls are really saved (refresh form).
[4] Check that you cannot complete a scan request without URL and that you
    cannot add a URL to a photocopy request.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 37 Martin Renvoize 2021-06-24 10:08:10 UTC
Created attachment 122377 [details] [review]
Bug 20472: Add format to sample notices

NOTE: We are only changing English here. A follow-up will care for
the translated languages. (English is in yml format, the remainder
not yet.)

We need to change the following notices:
AR_SLIP, AR_CANCELED, AR_PROCESSING, AR_PENDING and AR_COMPLETED.
In AR_COMPLETED the last sentence about picking up has been modified
too.

Test plan:
Reinstall Koha. Choose English. Check notice text.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 38 Martin Renvoize 2021-06-24 10:08:14 UTC
Created attachment 122378 [details] [review]
Bug 20472: Update translated AR notices

Originally, we had:
de-DE/mandatory/sample_notices.sql
fr-CA/obligatoire/sample_notices.sql
fr-FR/1-Obligatoire/sample_notices.sql
it-IT/necessari/notices.sql
nb-NO/1-Obligatorisk/sample_notices.sql
pl-PL/mandatory/sample_notices.sql
ru-RU/mandatory/sample_notices.sql
uk-UA/mandatory/sample_notices.sql

Obviously, the landscape changed in the meantime.
We still have: fr-CA, fr-FR, nb-NO.

Test plan:
Reinstall notices for one of the languages above.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Have run all sql files thru mysql on the command line.
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 39 Martin Renvoize 2021-06-24 10:08:19 UTC
Created attachment 122379 [details] [review]
Bug 20472: [DO NOT PUSH] DBIx schema changes

Refreshed 24-06-21

Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 40 Martin Renvoize 2021-06-24 10:09:16 UTC
This works really nicely and the code is nice and clean.. Signing off.

However.. QA script highlights some missing filters.. a quick follow-up should resolve those ;)
Comment 41 Marcel de Rooy 2021-06-24 12:13:02 UTC
Created attachment 122382 [details] [review]
Bug 20472: (QA follow-up) Add few TT filters

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
No more warns from qa tools.
Comment 42 Marcel de Rooy 2021-06-24 12:13:05 UTC
Created attachment 122383 [details] [review]
Bug 20472: [DO NOT PUSH] DBIx schema changes

Refreshed 24-06-21

Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 43 Martin Renvoize 2021-06-24 13:31:21 UTC
(In reply to Marcel de Rooy from comment #25)
> Note for QA:
> 
> Should we try to update existing notices here too ?

No we have logs for notices changes, we could theoretically try.. but I don't see that as a blocker for this either.
Comment 44 Nick Clemens 2021-07-09 11:09:10 UTC
Created attachment 122699 [details] [review]
Bug 20472: Add new fields article_requests.format and urls

The field 'format' will allow to make a distinction between requests for
photocopies and digital scans.
The field 'urls' will be used to save the URLs that allow the client to
download the scanned materials.

Test plan:
Run new install or upgrade existing install with atomic update.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 45 Nick Clemens 2021-07-09 11:09:14 UTC
Created attachment 122700 [details] [review]
Bug 20472: Db rev for new preference ArticleRequestsSupportedFormats

This preference controls which formats are actually offered to patrons of
the library via the Article Request feature.
By default, it only contains PHOTOCOPY. This is default behavior.

The request format SCAN will be made possible by this report and can be
added by changing the preference.

Test plan:
Run the dbrev. Check the new pref on Administration.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 46 Nick Clemens 2021-07-09 11:09:22 UTC
Created attachment 122701 [details] [review]
Bug 20472: Add format field to the interface

We need to add the format to the forms entering new requests:
  opac/opac-request-article
  circ/request-article
If the pref contains multiple formats like SCAN|PHOTOCOPY, the first listed
format will be preselected on the request form. If there is only one option,
we should not disable the select however. (Possibly hide it.)

If we have no mandatory fields, we should not allow the submit of a complete
empty form (check on OPAC).

And we need to show the format of pending requests on forms:
  opac/opac-user
  circ/request-article (biblio detail tab)
  circ/article-requests (staff form to handle requests)
  members/moremember (Article requests tab at the bottom)
  circ/circulation (Checkout/Article requests tab)
Note: The last two forms use the same include file.

Test plan:
[1] Add an article request via opac or staff. Choose Scan.
[2] Verify that you see the Scan format on opac-user and the
    above-mentioned staff forms.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 47 Nick Clemens 2021-07-09 11:09:33 UTC
Created attachment 122702 [details] [review]
Bug 20472: Edit URL field on staff form

This patch makes the following changes:

Add menu option Edit URLs.
Edit modal form to edit URLs.
Save URLs via ajax call to svc/article_request (Add action update_urls).
Add URL column to pending and processing table.
Allow Edit URLs for pending table too (just as Complete).
Do not allow 'Complete request' if a scan request has no URL(s).

Test plan:
[1] Add a few scan and photocopy requests.
[2] Fill url-A and url-B in two separate scan requests.
[3] Verify that these two urls are really saved (refresh form).
[4] Check that you cannot complete a scan request without URL and that you
    cannot add a URL to a photocopy request.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 48 Nick Clemens 2021-07-09 11:09:40 UTC
Created attachment 122703 [details] [review]
Bug 20472: Add format to sample notices

NOTE: We are only changing English here. A follow-up will care for
the translated languages. (English is in yml format, the remainder
not yet.)

We need to change the following notices:
AR_SLIP, AR_CANCELED, AR_PROCESSING, AR_PENDING and AR_COMPLETED.
In AR_COMPLETED the last sentence about picking up has been modified
too.

Test plan:
Reinstall Koha. Choose English. Check notice text.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 49 Nick Clemens 2021-07-09 11:09:55 UTC
Created attachment 122704 [details] [review]
Bug 20472: Update translated AR notices

Originally, we had:
de-DE/mandatory/sample_notices.sql
fr-CA/obligatoire/sample_notices.sql
fr-FR/1-Obligatoire/sample_notices.sql
it-IT/necessari/notices.sql
nb-NO/1-Obligatorisk/sample_notices.sql
pl-PL/mandatory/sample_notices.sql
ru-RU/mandatory/sample_notices.sql
uk-UA/mandatory/sample_notices.sql

Obviously, the landscape changed in the meantime.
We still have: fr-CA, fr-FR, nb-NO.

Test plan:
Reinstall notices for one of the languages above.

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Have run all sql files thru mysql on the command line.
Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 50 Nick Clemens 2021-07-09 11:10:06 UTC
Created attachment 122705 [details] [review]
Bug 20472: (QA follow-up) Add few TT filters

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
No more warns from qa tools.

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 51 Nick Clemens 2021-07-09 11:10:14 UTC
Created attachment 122706 [details] [review]
Bug 20472: [DO NOT PUSH] DBIx schema changes

Refreshed 24-06-21

Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>

Signed-off-by: Nick Clemens <nick@bywatersolutions.com>
Comment 52 Marcel de Rooy 2021-07-09 11:38:37 UTC
(In reply to Nick Clemens from comment #44)
> Signed-off-by: Nick Clemens <nick@bywatersolutions.com>

Great! Thx
Comment 53 Jonathan Druart 2021-07-12 11:52:21 UTC
Created attachment 122775 [details] [review]
Bug 20472: Make DB rev idempotent
Comment 54 Jonathan Druart 2021-07-12 13:37:40 UTC
Created attachment 122781 [details] [review]
Bug 20472: Add kohastructure changes
Comment 55 Jonathan Druart 2021-07-12 13:48:29 UTC
Pushed to master for 21.11, thanks to everybody involved!
Comment 56 Marcel de Rooy 2021-07-12 13:55:08 UTC
(In reply to Jonathan Druart from comment #54)
> Created attachment 122781 [details] [review] [review]
> Bug 20472: Add kohastructure changes

Thanks. Is that really true :) Somewhere it has got lost in the rebase. The first obsolete patch included it, aarg.
Comment 57 Kyle M Hall 2021-07-23 11:39:45 UTC
Enhancement not backported for 21.05